import { IUserRepository } from '@goodrequest/passport-jwt-wrapper';
import { Transaction } from 'sequelize';
import { UserModel } from './models/user';
export declare class UserRepository<M extends typeof UserModel> implements IUserRepository<number> {
    user: M;
    constructor(user: M);
    getUsers(limit: number, page: number, sort: string, search?: string): Promise<UserModel[]>;
    getUserByEmail(email: string): Promise<UserModel | undefined>;
    getUserById(id: number): Promise<UserModel | undefined>;
    updateUserPassword(id: number, newPassword: string, transaction?: Transaction): Promise<void>;
    /**
     * return user only if he has no password set -- is not registered
     * @param userID
     */
    getNewUserById(userID: number): Promise<UserModel | undefined>;
}
