/* eslint-disable import/no-cycle */
import { Model } from 'sequelize'

export class UserModel extends Model {
	declare id: number
	declare email: string
	declare emailSlug: string
	declare name?: string
	declare nameSlug?: string
	declare surname?: string
	declare surnameSlug?: string
	declare hash: string
	declare confirmedAt: string
	// foreign keys
	/* eslint-disable no-use-before-define */
	declare createdBy: number
	declare creator: UserModel
	declare updatedBy: number
	declare editor: UserModel
	declare deletedBy: number
	declare destructor: UserModel
	/* eslint-enable no-use-before-define */
	// metadata
	declare createdAt: string
	declare updatedAt: string
	declare deletedAt: string
}

function defineUserModel() {
	return UserModel
}

export default defineUserModel()
